# Jenkins Plugin Manager

This repository contains the jenkins\_plugin\_manager python module.
this module allows a management of the Jenkins plugins and their dependencies as well as getting them

The Launchpad project can be found
[here](https://launchpad.net/jenkins-plugin-manager).

The code for this repository can be cloned with:

  git clone git+ssh://git.launchpad.net/jenkins-plugin-manager

## Code Location

The Python code can be found at `./jenkins_plugin_manager.py`, with tests in the
`tests` directory. Lint configuration can be found in `./.flake8`.

## Testing Code

To get started, you need `make` and `tox`.

  make install-build-depends
  make test

## Building a Release

The release process for a project would normally be something like:

  [edit setup.py with the right version number (if applicable)]
  make dch
  [check and edit debian/changelog]
  git commit -m 'x.y.z release'  debian/changelog
  export GPG\_TTY=$(tty)
  git tag -s -u <keyid> -m 'x.y.z release' x.y.z
  git push --tags
  make deb-src
  dput ppa:jenkins-plugin-manager-devs/jpm-devel ../python3-jenkins-plugin-manager\_x.y.z\_source.changes

Where `x.y.z` is the appropriate version number.
This will upload the debian source package to the
[devel PPA](https://launchpad.net/~jenkins-plugin-manager-devs/+archive/ubuntu/jpm-devel)
for building.

Once the new packages have been successfully tested, they can be
[copied](https://launchpad.net/~jenkins-plugin-manager-devs/+archive/ubuntu/jpm-devel/+copy-packages)
as binary packages (not rebuilt from source) to the
[production  PPA](https://launchpad.net/~jenkins-plugin-manager-devs/+archive/ubuntu/jpm)
The production environment can then be updated from this PPA.
