"""Jenkins Plugin Manager module."""

# Always prefer setuptools over distutils
from setuptools import setup, find_packages
from os import path

here = path.abspath(path.dirname(__file__))

# Get the long description from the README file
with open(path.join(here, "README.md"), encoding="utf-8") as f:
    long_description = f.read()

# Arguments marked as "Required" below must be included for upload to PyPI.
# Fields marked as "Optional" may be commented out.

setup(
    name="jenkins-plugin-manager",  # Required
    version="0.3",  # Required
    description="Manage Jenkins plugin (get dependencies, download them)",  # Optional
    long_description=long_description,  # Optional
    long_description_content_type="text/markdown",  # Optional (see note above)
    url="https://launchpad.net/jenkins-plugin-manager",  # Optional
    author="Benjamin Allot",  # Optional
    author_email="benjamin.allot@canonical.com",  # Optional
    classifiers=[  # Optional
        "Development Status :: 3 - Alpha",
        "Intended Audience :: Developers",
        "Topic :: Software Development :: Build Tools",
        "License :: OSI Approved :: MIT License",
        "Programming Language :: Python :: 3",
    ],
    keywords="jenkins",  # Optional
    packages=find_packages(exclude=["tests"]),  # Required
    install_requires="setuptools",
    python_requires=">=3.3",
    extras_require={"test": ["coverage"]},  # Optional
    # For example, the following would provide a command called `sample` which
    # executes the function `main` from this package when invoked:
    entry_points={"console_scripts": ["jenkins-plugin-manager=jenkins_plugin_manager.main:main"]},  # Optional
    project_urls={  # Optional
        "Bug Reports": "https://bugs.launchpad.net/jenkins-plugin-manager",
        "Source": "https://code.launchpad.net/jenkins-plugin-manager",
    },
)
